function cameraTypeChanged(target) {
    require(["dojo/query", "dojo/NodeList-manipulate"], function(query){
        var freeDefId = query("[name^='freeDefinedCamId']").attr("value");

        if(freeDefId == target.value) {
            dojo.forEach(dojo.query("[name^='camUrl']"), function(domnode) {
                dijit.getEnclosingWidget(domnode).set("disabled", false);
            });

            dojo.forEach(dojo.query("[name^='camHostname']"), function(domnode) {
                //dijit.getEnclosingWidget(domnode).set("value", "");
                dijit.getEnclosingWidget(domnode).set("disabled", true);
            });
            dojo.forEach(dojo.query("[name^='camPort']"), function(domnode) {
                //dijit.getEnclosingWidget(domnode).set("value", "");
                dijit.getEnclosingWidget(domnode).set("disabled", true);
            });
        } else {
            dojo.forEach(dojo.query("[name^='camUrl']"), function(domnode) {
                //dijit.getEnclosingWidget(domnode).set("value", "");
                dijit.getEnclosingWidget(domnode).set("disabled", true);
            });

            dojo.forEach(dojo.query("[name^='camHostname']"), function(domnode) {
                dijit.getEnclosingWidget(domnode).set("disabled", false);
            });
            dojo.forEach(dojo.query("[name^='camPort']"), function(domnode) {
                dijit.getEnclosingWidget(domnode).set("disabled", false);
            });
        }
    });
}

function assignValFunction(inputName){
    require(["dijit/form/ValidationTextBox", "dojo/ready"], function(ValidationTextBox, ready){
        ready(function(){
            dojo.forEach(dojo.query("[name^=\'" + inputName + "\']"), function(domnode) {
                dijit.getEnclosingWidget(domnode).validator = function(value, constraints){
                    if(!value || value.length == 0 ){
                        return false;
                    }else{
                        return true;
                    }
                };
            });
        });
    });
}

function connectFormValidator(valCtrls) {
    for (var i = 0; i < valCtrls.length; i++) {
        assignValFunction(valCtrls[i]);
        dojo.forEach(dojo.query("[name^='" + valCtrls[i] + "']"), function(domnode) {
            dijit.getEnclosingWidget(domnode).validate();
        });
    }
}

function disableCtrls(ctrls, shouldDisable) {
    for (var i = 0; i < ctrls.length; i++) {
        assignValFunction(ctrls[i]);
        dojo.forEach(dojo.query("[name^='" + ctrls[i] + "']"), function(domnode) {
            dijit.getEnclosingWidget(domnode).set("disabled", shouldDisable);
        });
    }
}

function cmdGuiTypeChanged(target) {
    require(["dojo/query", "dojo/NodeList-manipulate"], function(query){
        var isDtmf = false;
        dojo.forEach(dojo.query("[name^='cmdCrtlType']"), function(domnode) {
            if(dijit.getEnclosingWidget(domnode).get("value") == "DTMF") {
                isDtmf = true;
            }
        });

        if("Button" === target.value) {
            disableCtrls(['cmdDtmfOnTone', 'cmdOnTitle', 'cmdDtmfOffTone', 'cmdOffTitle'], true);
            disableCtrls(['cmdGuiColor'], false);
            disableCtrls(['cmdDtmfTone'], !isDtmf);
        } else {
            disableCtrls(['cmdOnTitle', 'cmdOffTitle'], false);
            disableCtrls(['cmdGuiColor', 'cmdDtmfTone'], true);
            disableCtrls(['cmdDtmfOnTone', 'cmdDtmfOffTone'], !isDtmf);
        }
    });
}
function cmdOnTitleChanged(target){}
function cmdOffTitleChanged(target){}
function cmdGuiColorChanged(target){}
function cmdControllerIdChanged(target){}
function doorMsnChanged(target){}
function cmdRelayTypeChanged(target){}

function formValidateAndPut(formName, apiName, valCtrls) {
    require(["dojo/dom-form", "dojo/request", "dojo/query", "dojo/NodeList-manipulate", "dijit/Tree", "dojo/data/ItemFileReadStore"], function(domForm, request, query){
        var isFormOk = true;

        for (var i = 0; i < valCtrls.length; i++) {
            dojo.forEach(dojo.query("[name^='" + valCtrls[i] + "']"), function(domnode) {
                dijit.getEnclosingWidget(domnode).validate();
                if(!dijit.getEnclosingWidget(domnode).isValid()){
                    dijit.getEnclosingWidget(domnode).focus();
                    dijit.getEnclosingWidget(domnode).displayMessage('Mandatory');
                    isFormOk = false;
                }
            });

            if(!isFormOk) {
                return;
            }
        }

        var formJson = domForm.toJson(formName);
        request.put('/iDorMobile/ConfigServer/api.php/' + apiName,
            {data: formJson, headers:{'Content-Type':'application/json;charset=UTF-8'}}
        ).then(function(data){
            try{
                var obj = JSON.parse(data);
                document.getElementById('cfg-def-block').innerHTML = '';
                document.getElementById('cfg-def-block').innerHTML = obj.msg;
                dojo.parser.parse('cfg-def-block');
                if(obj.success) {
                    dijit.byId('config-blocks-tree').destroy(true);
                    createCfgBlocksTree();
                    if(apiName === 'command'){
                        dijit.byId('config-blocks-tree').set('path', ['cfgBlocks', 'controls', obj.commandType, '0'] );
                    } else {
                        dijit.byId('config-blocks-tree').set('path', ['cfgBlocks', apiName, '0'] );
                    }
                }
             } catch (e) {
                 document.getElementById('cfg-def-block').innerHTML = '';
                 document.getElementById('cfg-def-block').innerHTML = data;
             }
        }, function(err){
            document.getElementById('cfg-def-block').innerHTML = '';
            document.getElementById('cfg-def-block').innerHTML = err;
        });
    });
}

function callDeleteApi(formName, apiName) {
    require(["dojo/dom-form", "dojo/request", "dojo/query", "dojo/NodeList-manipulate", "dijit/Tree", "dojo/data/ItemFileReadStore"], function(domForm, request, query){
        var formJson = domForm.toJson(formName);
        request.del('/iDorMobile/ConfigServer/api.php/' + apiName,
            {data: formJson, headers:{'Content-Type':'application/json;charset=UTF-8'}}
        ).then(function(data){
            try {
                var obj = JSON.parse(data);
                document.getElementById('cfg-def-block').innerHTML = '';
                document.getElementById('cfg-def-block').innerHTML = obj.msg;
                dojo.parser.parse('cfg-def-block');
                if(obj.success) {
                    dijit.byId('config-blocks-tree').destroy(true);
                    createCfgBlocksTree();
                    if(apiName === 'command'){
                        dijit.byId('config-blocks-tree').set('path', ['cfgBlocks', 'controls', obj.commandType, '0'] );
                    } else {
                        dijit.byId('config-blocks-tree').set('path', ['cfgBlocks', apiName, '0'] );
                    }
                }
            } catch (e) {
                document.getElementById('cfg-def-block').innerHTML = '';
                document.getElementById('cfg-def-block').innerHTML = data;
                return;
            }
        }, function(err){
            document.getElementById('cfg-def-block').innerHTML = '';
            document.getElementById('cfg-def-block').innerHTML = err;
        });
    });
}

function callDuplicateApi(formName, apiName) {
    require(["dojo/dom-form", "dojo/request", "dojo/query", "dojo/NodeList-manipulate", "dijit/Tree", "dojo/data/ItemFileReadStore"], function(domForm, request, query){
        var formJson = domForm.toJson(formName);
        request.put('/iDorMobile/ConfigServer/api.php/duplicate',
            {data:formJson, headers:{'Content-Type':'application/json;charset=UTF-8'}}
        ).then(function(data){
            try {
                var obj = JSON.parse(data);
                document.getElementById('cfg-def-block').innerHTML = '';
                document.getElementById('cfg-def-block').innerHTML = obj.msg;
                dojo.parser.parse('cfg-def-block');
                if(obj.success) {
                    dijit.byId('config-blocks-tree').destroy(true);
                    createCfgBlocksTree();
                    if(apiName === 'command'){
                        dijit.byId('config-blocks-tree').set('path', ['cfgBlocks', 'controls', obj.commandType, '0'] );
                    } else {
                        dijit.byId('config-blocks-tree').set('path', ['cfgBlocks', apiName, '0'] );
                    }
                }
            } catch (e) {
                document.getElementById('cfg-def-block').innerHTML = '';
                document.getElementById('cfg-def-block').innerHTML = data;
                return;
            }
        }, function(err){
            document.getElementById('cfg-def-block').innerHTML = '';
            document.getElementById('cfg-def-block').innerHTML = err;
        });
    });
}

function getForm(type, dataId, ctrlVal) {
    require(["dojo/request"], function(request){
        request.get("editForms.php", {
            query: {
                type: type,
                id: dataId
            }
        }).then(function(text){
            document.getElementById('cfg-def-block').innerHTML = "";
            document.getElementById('cfg-def-block').innerHTML = text;
            dojo.parser.parse('cfg-def-block').then(function() {
                connectFormValidator(ctrlVal);
            });
        });
    });
}

function onChangeConciergeCall(target) {
    require(["dojo/query", "dojo/NodeList-manipulate"], function(query){
        if(target) {
            disableCtrls(['sipDefMainDoorMSN', 'sipDefCallButtonName'], false);
        } else {
            disableCtrls(['sipDefMainDoorMSN', 'sipDefCallButtonName'], true);
        }
    });
}

function onChangeDoorType(target) {
    require(["dojo/query", "dojo/NodeList-manipulate", "dijit/form/TextBox"], function(query){
        if(target) {
            if ('iDor' === target.value && target.checked) {
                dojo.query('[name="sipDefOpenDoorDTMF"]')[0].value = "#";  
                dojo.query('[name="sipDefAnswerDoorDTMF"]')[0].value = "1";  
                dojo.query('[name="sipDefHangUpDTMF"]')[0].value = "1"; 
            } else if ('Siedle' === target.value && target.checked) {
                dojo.query('[name="sipDefOpenDoorDTMF"]')[0].value = "#61";  
                dojo.query('[name="sipDefAnswerDoorDTMF"]')[0].value = "5";  
                dojo.query('[name="sipDefHangUpDTMF"]')[0].value = "#0";
            } else if ('iDM' === target.value && target.checked) {
                dojo.query('[name="sipDefOpenDoorDTMF"]')[0].value = "#61";  
                dojo.query('[name="sipDefAnswerDoorDTMF"]')[0].value = "";  
                dojo.query('[name="sipDefHangUpDTMF"]')[0].value = "0";
            }
        }
    });
}

function onChangeInbandDTMF(target) {
    require(["dojo/query", "dojo/NodeList-manipulate"], function(query){
        if(target) {
            disableCtrls(['sipDefInbandDTMFClockRate', 'sipDefInbandDTMFChannels', 'sipDefInbandDTMFSamplesPerFrame', 'sipDefInbandDTMFBitsPerSample'], false);
        } else {
            disableCtrls(['sipDefInbandDTMFClockRate', 'sipDefInbandDTMFChannels', 'sipDefInbandDTMFSamplesPerFrame', 'sipDefInbandDTMFBitsPerSample'], true);
        }
    });
}

function onChangeSIPUseStunServers(target) {
    require(["dojo/query", "dojo/NodeList-manipulate"], function(query){
        if(target) {
            disableCtrls(['sipDefSTUNServer1', 'sipDefSTUNServer2', 'sipDefSTUNServer3', 'sipDefSTUNServer4'], false);
        } else {
            disableCtrls(['sipDefSTUNServer1', 'sipDefSTUNServer2', 'sipDefSTUNServer3', 'sipDefSTUNServer4'], true);
        }
    });
}

function onCfgBundleGlobal(checked) {
    if(checked) {
        disableCtrls(['cfgBundleApartmentId', 'cfgBundleUserId'], true);
    }
}

function onCfgBundleApartment(checked) {
    if(checked) {
        disableCtrls(['cfgBundleUserId'], true);
        disableCtrls(['cfgBundleApartmentId'], false);
    }
}
function onCfgBundleUser(checked) {
    if(checked) {
        disableCtrls(['cfgBundleUserId'], false);
        disableCtrls(['cfgBundleApartmentId'], true);
    }
}
