<?php

namespace iDorMobile;

include_once 'DbUtils.php';
include_once 'GuiUtils.php';

class FormsGenerator
{
    public static function isAuthenticated() {
        session_start();
        if (isset($_SESSION['user_level'])) {
            if ($_SESSION['user_level'] >= 20) {
                return true;
            }
        }
        echo '<div id="error-msg">Login Expire. Please logout and login again.</div>';
        exit;
    }

    public static function apartmentForm($id) {
        FormsGenerator::isAuthenticated();
        $sql = 'SELECT id, name, number, caller_number, contact_email, contact_number FROM apartments WHERE id=';
        $dbData = DBUtils::getDbData('sip', 'apartment', $sql, $id);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }
//      return json_encode($dbData);

        $response = '<div id="form-div">';
        $response .= '<form><table>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('apartmentName') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['name'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('callerNumber') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['caller_number'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('number') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['number'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('email') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['contact_email'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('phone') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['contact_number'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';
        $response .= '</table>';

        $sql = 'select priority, ring_time, sip_accounts from call_routings where apartment_id=';
        $dbData = DBUtils::getDbData('sip', 'call route', $sql, $id);
        if(!isset($dbData['error'])) {
            //$response .= '<br /><br /><table><tr><td class="table-col-input" colspan="3"><strong>' . GuiUtils::getSessionLocalizedString('callRoutes') . '</strong></td></tr>';
            $response .= '<br /><br /><h3>' . GuiUtils::getSessionLocalizedString('callRoutes') . '</h3>';
            $response .= '<table><tr><td class="table-col-input"><strong>' . GuiUtils::getSessionLocalizedString('priority') . '</strong></td>';
            $response .= '<td class="table-col-input"><strong>' . GuiUtils::getSessionLocalizedString('ringingTime') . '</strong></td>';
            $response .= '<td class="table-col-input"><strong>' . GuiUtils::getSessionLocalizedString('ringingAccounts') . '</strong></td></tr>';
            foreach($dbData as $row) {
                $response .= '<tr><td class="table-col-input"><input type="text" name="name" value="' . $row['priority'] . '" dojoType="dijit.form.NumberTextBox" readOnly="true" /></td>';
                $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $row['ring_time'] . '" dojoType="dijit.form.NumberTextBox" readOnly="true" /></td>';
                $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $row['sip_accounts'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></tr>';
            }
            $response .= '</table>';
        }

        $response .= '</form></div>';
        return $response;
    }

    public static function sipDoorsForm($id) {
        FormsGenerator::isAuthenticated();
        $sql = 'select id, name, location, device_type, username, authname, password from door_modules where id=';
        $dbData = DBUtils::getDbData('sip', 'door', $sql, $id);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }

        $response = '<div id="form-div">';
        $response .= '<form><table>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('doorName') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['name'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('doorLocation') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['location'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('deviceType') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['device_type'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('username') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['username'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('authname') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['authname'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('password') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['password'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';

        $response .= '</table></form></div>';
        return $response;
    }

    public static function sipAccountsForm($id) {
        FormsGenerator::isAuthenticated();
        $sql = 'select acc.id, ap.name apartment, acc.name, acc.device_type, acc.username, acc.authname, acc.password, acc.active from sip_accounts acc, apartments ap where ap.id=acc.apartment_id and acc.id=';
        $dbData = DBUtils::getDbData('sip', 'sip account', $sql, $id);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }

        $response = '<div id="form-div">';
        $response .= '<form><table>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('sipAccountName') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['name'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('sipAccountApartment') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['apartment'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('deviceType') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['device_type'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('username') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['username'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('authname') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['authname'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('password') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="text" name="name" value="' . $dbData[0]['password'] . '" dojoType="dijit.form.TextBox" readOnly="true" /></td></td>';

        $checked = "";
        if($dbData[0]['active']  == '1') {
            $checked = "checked ";
        }
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('active') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input type="checkbox" ' . $checked . 'name="name" dojoType="dijit.form.CheckBox" readOnly="true" /></td></td>';
        $response .= '</table></form></div>';

        return $response;
    }

    public static function cameraForm($id) {
        FormsGenerator::isAuthenticated();
        $sql = 'select id, name, standard_url from camera_types';
        $dbData = DBUtils::getDbData('cfg', 'camera configuration', $sql, 0);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }

        $dbCamData = null;
        if($id > 0) {
            $sql = 'select id, name, camera_type_id, url, hostname, port, username, password, realm from cameras where id=';
            $dbCamData = DBUtils::getDbData('cfg', 'camera configuration', $sql, $id);
            if(isset($dbCamData['error'])) {
                return $dbCamData['error'];
            }
        }

        $camTypeSelect = '<select name="camTypeId" style="width: 100%;" data-dojo-type="dijit/form/Select" onChange="cameraTypeChanged(this)">';
        $disabledHostAndPort = " disabled=false ";
        $disabledUrl = " disabled=true ";
        $freeDefinedIdHiddenInput = "";
        $freeDefinedId = "0";
        foreach($dbData as $row) {
            $selected = "";
            if($id > 0 && $dbCamData[0]['camera_type_id'] == $row['id']) {
                $selected = ' selected="selected"';
            }

            if($row['name'] == 'Free Defined') {
                $freeDefinedIdHiddenInput = '<input type="hidden" name="freeDefinedCamId" dojoType="dijit.form.TextBox" value="' . $row['id'] . '"/>';
                $freeDefinedId = $row['id'];
                if($id == 0 || strlen($selected) > 0) {
                    $selected = ' selected="selected"';
                    $disabledHostAndPort = " disabled=true ";
                    $disabledUrl = " disabled=false ";
                }
            }
            $camTypeSelect .= '<option value="' . $row['id']  . '"' . $selected . '>' . $row['name'] . '</option>';
        }
        $camTypeSelect .= '</select>';

        $response = '<div id="form-div">';
        $response .= '<form id="camerasForm">';
        $response .= '<table>' . $freeDefinedIdHiddenInput;

        $response .= '<input type="hidden" name="camId" value="' . $id . '"/>';
        $response .= '<input type="hidden" name="dupId" value="' . $id . '"/>';
        $response .= '<input type="hidden" name="dupliType" value="camera"/>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('name') . '</strong></label></td>';
        $val = isset($dbCamData[0]['name']) ? $dbCamData[0]['name'] : "";

        $response .= '<td class="table-col-input"><input type="text" name="camName" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/ValidationTextBox" required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('name') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"/></td></tr>';


        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('type') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $camTypeSelect . '</td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('url') . '</strong></label></td>';
        $val = isset($dbCamData[0]['url']) ? $dbCamData[0]['url'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="camUrl" value="' . $val .  '" ';
        $response .= 'dojoType="dijit.form.ValidationTextBox" required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('name') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"';
        $response .= $disabledUrl . '/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('hostname') . '</strong></label></td>';
        $val = isset($dbCamData[0]['hostname']) ? $dbCamData[0]['hostname'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="camHostname" dojoType="dijit.form.ValidationTextBox" value="' . $val .  '" ';
        $response .= 'required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('hostname') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"';
        $response .= $disabledHostAndPort .'/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('port') . '</strong></label></td>';
        $val = isset($dbCamData[0]['port']) && $dbCamData[0]['port'] > 0 ? $dbCamData[0]['port'] : "80";
        $response .= '<td class="table-col-input"><input type="text" name="camPort" dojoType="dijit.form.NumberTextBox" value="' . $val .  '" ';
        $response .= 'data-dojo-props="constraints:{min:1,max:65535,places:0,pattern:\'#\'}, invalidMessage:\'' . GuiUtils::getSessionLocalizedString('invalidPortNumber') . '\'"'  . $disabledHostAndPort .'/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('username') . '</strong></label></td>';
        $val = isset($dbCamData[0]['username']) ? $dbCamData[0]['username'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="camUsername" dojoType="dijit.form.TextBox" value="' . $val .  '" /></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('password') . '</strong></label></td>';
        $val = isset($dbCamData[0]['password']) ? $dbCamData[0]['password'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="camPassword" dojoType="dijit.form.TextBox" value="' . $val .  '"/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('authenticationRealm') . '</strong></label></td>';
        $val = isset($dbCamData[0]['realm']) ? $dbCamData[0]['realm'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="camRealm" dojoType="dijit.form.TextBox" value="' . $val .  '"/></td></tr>';


        $sql = "select id, name from doors";
        $dbData = DBUtils::getDbData('cfg', 'cam configuration', $sql, 0, 0);
        if(isset($dbData['error'])) {
            $dbData = array();
        }

        $selectedDoors = null;
        if($id > 0) {
            $sql = "select door_id as id from door_cam_link where cam_id=";
            $selectedDoors = DBUtils::getDbData('cfg', 'cam configuration', $sql, $id, 0);
            if(isset($dbData['error'])) {
                return $dbData['error'];
            }
        }
        $camDoorsSelect = FormsGenerator::buildMultiSelectBox('camDoors', $dbData, $selectedDoors);

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('door') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $camDoorsSelect . '</td></tr>';
        $response .= '<tr><td class="table-col-label">&nbsp;</td>';
        $response .= '<td class="table-col-submit">';
        if($id > 0) {
            $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('duplicate');
            $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
            $response .= "callDuplicateApi('camerasForm', 'camera');";
            $response .= '</script>';
            $response .= '</button>';

            $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('delete');
            $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
            $response .= "callDeleteApi('camerasForm', 'camera');";
            $response .= '</script>';
            $response .= '</button>';
        }

        $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('save');
        $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
        $response .= '
                require(["dojo/dom-form", "dojo/query", "dojo/NodeList-manipulate",], function(domForm, query){
                    dojo.forEach(dojo.query("[name^=\'camTypeId\']"), function(domnode) {
                        if(dijit.getEnclosingWidget(domnode).get(\'value\') == ' . $freeDefinedId  . ') {';
        $response .= "      formValidateAndPut('camerasForm', 'camera', ['camName', 'camUrl']);";
        $response .= "  } else {";
        $response .= "      formValidateAndPut('camerasForm', 'camera', ['camName', 'camHostname', 'camPort']);";
        $response .= '  }});});';
        $response .= '</script>';
        $response .= '</button></td></td>';

        $response .= '</table></form></div>';
        $dbCamData = null;
        return $response;
    }

    public static function buildSelectBox($name, $selectOptions, $enabledVal, $isDisabled=false) {
        $selectCtrlStr = '<select name="' . $name .'" style="width: 100%;" data-dojo-type="dijit/form/Select" ';
        $disabled = $isDisabled ? 'true' : 'false';
        $selectCtrlStr .= 'disabled="' . $disabled . '" onChange="' . $name .'Changed(this)">';
        foreach($selectOptions as $row) {
            $selected = "";
            if($enabledVal == "-1"){
                if($row['isDefault']) {
                    $selected = ' selected="selected"';
                }
            } else if($enabledVal == $row['val']) {
                $selected = ' selected="selected"';
            }
            $selectCtrlStr .= '<option value="' . $row['val']  . '"' . $selected . '>' . $row['name'] . '</option>';
        }

        $selectCtrlStr .= '</select>';
        return $selectCtrlStr;
    }

    public static function commandDtmfForm($id) {
        FormsGenerator::isAuthenticated();
        $dbCmdData = null;
        $isWebRelayType = false;
        $isButtonType = false;
        if($id > 0) {
            $sql = "select * from commands where controller_type = 'DTMF' and id=";
            $dbCmdData = DBUtils::getDbData('cfg', 'command configuration', $sql, $id);
            if(isset($dbCmdData['error'])) {
                return $dbCmdData['error'] . $sql;
            }
            $isButtonType = $dbCmdData[0]['gui_type'] == 'Button';
        }

        $sql = "select name, val, isDefault from cmd_gui_support where type_name='guiType'";
        $dbData = DBUtils::getDbData('cfg', 'command configuration', $sql, 0);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }
        $cmdGuiSelect = FormsGenerator::buildSelectBox('cmdGuiType', $dbData, isset($dbCmdData[0]['gui_type']) ? $dbCmdData[0]['gui_type'] : "-1");

        $sql = "select name, val, isDefault from cmd_gui_support where type_name='guiColor'";
        $dbData = DBUtils::getDbData('cfg', 'command configuration', $sql, 0);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }
        $cmdColorSelect = FormsGenerator::buildSelectBox('cmdGuiColor', $dbData, isset($dbCmdData[0]['color']) ? $dbCmdData[0]['color'] : "-1", !$isButtonType);

        $sql = "select name, val, isDefault from cmd_gui_support where type_name='onTitle'";
        $dbData = DBUtils::getDbData('cfg', 'command configuration', $sql, 0);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }
        $cmdOnTitle = FormsGenerator::buildSelectBox('cmdOnTitle', $dbData, isset($dbCmdData[0]['on_title']) ? $dbCmdData[0]['on_title'] : "-1", $isButtonType);
        $sql = "select name, val, isDefault from cmd_gui_support where type_name='offTitle'";
        $dbData = DBUtils::getDbData('cfg', 'command configuration', $sql, 0);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }
        $cmdOffTitle = FormsGenerator::buildSelectBox('cmdOffTitle', $dbData, isset($dbCmdData[0]['off_title']) ? $dbCmdData[0]['off_title'] : "-1", $isButtonType);

        $response = '<div id="form-div">';
        $response .= '<form id="commandDtmfForm">';
        $response .= '<table>';
        $response .= '<input type="hidden" name="cmdId" value="' . $id . '"/>';
        $response .= '<input type="hidden" name="dupId" value="' . $id . '"/>';
        $response .= '<input type="hidden" name="dupliType" value="command"/>';
        $response .= '<input type="hidden" name="commandType" value="DTMF"/>';
        $response .= '<input type="hidden" dojoType="dijit.form.TextBox" name="cmdCrtlType" value="DTMF"/>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('name') . '</strong></label></td>';
        $val = isset($dbCmdData[0]['name']) ? $dbCmdData[0]['name'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="cmdName" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/ValidationTextBox" required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{1,12}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('name') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('cmdInterfaceType') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $cmdGuiSelect . '</td></tr>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('cmdInterfaceColor') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $cmdColorSelect . '</td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('buttonDtmf') . '</strong></label></td>';
        $val = isset($dbCmdData[0]['dtmf_cmd']) ? $dbCmdData[0]['dtmf_cmd'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="cmdDtmfTone" value="' . $val .  '" ';
        $response .= 'dojoType="dijit.form.ValidationTextBox" required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('buttonDtmf') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"';

        $isDisabled = !$isButtonType ? 'true' : 'false';
        $response .= ' disabled="' . $isDisabled . '" /></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('switchOnDtmf') . '</strong></label></td>';
        $val = isset($dbCmdData[0]['dtmf_cmd_on']) ? $dbCmdData[0]['dtmf_cmd_on'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="cmdDtmfOnTone" value="' . $val .  '" ';
        $response .= 'dojoType="dijit.form.ValidationTextBox" required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
         $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('switchOnDtmf') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"';

        $isDisabled = $isButtonType ? 'true' : 'false';
        $response .= ' disabled="' . $isDisabled . '" /></td></tr>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('switchOffDtmf') . '</strong></label></td>';
        $val = isset($dbCmdData[0]['dtmf_cmd_off']) ? $dbCmdData[0]['dtmf_cmd_off'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="cmdDtmfOffTone" value="' . $val .  '" ';
        $response .= 'dojoType="dijit.form.ValidationTextBox" required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('switchOffDtmf') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"';

        $isDisabled = $isButtonType ? 'true' : 'false';
        $response .= ' disabled="' . $isDisabled . '" /></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('switchOnLabel') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $cmdOnTitle;
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('switchOffLabel') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $cmdOffTitle;

        $response .= '<tr><td class="table-col-label">&nbsp;</td>';
        $response .= '<td class="table-col-submit">';
        if($id > 0) {
            $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('duplicate');
            $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
            $response .= "callDuplicateApi('commandDtmfForm', 'command');";
            $response .= '</script>';
            $response .= '</button>';

            $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('delete');
            $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
            $response .= "callDeleteApi('commandDtmfForm', 'command');";
            $response .= '</script>';
            $response .= '</button>';
        }

        $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('save');
        $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
        $response .= '
                require(["dojo/dom-form", "dojo/query", "dojo/NodeList-manipulate",], function(domForm, query){
                    dojo.forEach(dojo.query("[name^=\'cmdGuiType\']"), function(domnode) {
                        if(dijit.getEnclosingWidget(domnode).get(\'value\') == \'Button\') {
                            formValidateAndPut(\'commandDtmfForm\', \'command\', [\'cmdName\', \'cmdDtmfTone\']);
                        } else {
                            formValidateAndPut(\'commandDtmfForm\', \'command\', [\'cmdName\',\'cmdDtmfOnTone\', \'cmdDtmfOffTone\']);
                        }
                    });
                });';
        $response .= '</script>';
        $response .= '</button></td></td>';
        $response .= '</table></form></div>';
        $dbCmdData = null;
        return $response;
    }

    public static function commandWRForm($id) {
        FormsGenerator::isAuthenticated();
        $dbCmdData = null;
        $isWebRelayType = false;
        $isButtonType = false;
        if($id > 0) {
            $sql = "select * from commands where controller_type = 'WR' and id=";
            $dbCmdData = DBUtils::getDbData('cfg', 'command configuration', $sql, $id);
            if(isset($dbCmdData['error'])) {
                return $dbCmdData['error'] . $sql;
            }
            $isButtonType = $dbCmdData[0]['gui_type'] == 'Button';
        }

        $sql = "select name, val, isDefault from cmd_gui_support where type_name='guiType'";
        $dbData = DBUtils::getDbData('cfg', 'command configuration', $sql, 0);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }
        $cmdGuiSelect = FormsGenerator::buildSelectBox('cmdGuiType', $dbData, isset($dbCmdData[0]['gui_type']) ? $dbCmdData[0]['gui_type'] : "-1");

        $sql = "select name, val, isDefault from cmd_gui_support where type_name='guiColor'";
        $dbData = DBUtils::getDbData('cfg', 'command configuration', $sql, 0);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }
        $cmdColorSelect = FormsGenerator::buildSelectBox('cmdGuiColor', $dbData, isset($dbCmdData[0]['color']) ? $dbCmdData[0]['color'] : "-1", !$isButtonType);

        $sql = "select name, val, isDefault from cmd_gui_support where type_name='onTitle'";
        $dbData = DBUtils::getDbData('cfg', 'command configuration', $sql, 0);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }
        $cmdOnTitle = FormsGenerator::buildSelectBox('cmdOnTitle', $dbData, isset($dbCmdData[0]['on_title']) ? $dbCmdData[0]['on_title'] : "-1", $isButtonType);
        $sql = "select name, val, isDefault from cmd_gui_support where type_name='offTitle'";
        $dbData = DBUtils::getDbData('cfg', 'command configuration', $sql, 0);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }
        $cmdOffTitle = FormsGenerator::buildSelectBox('cmdOffTitle', $dbData, isset($dbCmdData[0]['off_title']) ? $dbCmdData[0]['off_title'] : "-1", $isButtonType);
        $sql = "select name, val, isDefault from cmd_gui_support where type_name='idmRelayType'";
        $dbData = DBUtils::getDbData('cfg', 'command configuration', $sql, 0);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }
        $cmdRelayType = FormsGenerator::buildSelectBox('cmdRelayType', $dbData, isset($dbCmdData[0]['idm_relay_type']) ? $dbCmdData[0]['idm_relay_type'] : "-1");

        $response = '<div id="form-div">';
        $response .= '<form id="commandWrForm">';
        $response .= '<table>';
        $response .= '<input type="hidden" name="cmdId" value="' . $id . '"/>';
        $response .= '<input type="hidden" name="dupId" value="' . $id . '"/>';
        $response .= '<input type="hidden" name="dupliType" value="command"/>';
        $response .= '<input type="hidden" name="commandType" value="WR"/>';
        $response .= '<input type="hidden" dojoType="dijit.form.TextBox" name="cmdCrtlType" value="WR"/>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('name') . '</strong></label></td>';
        $val = isset($dbCmdData[0]['name']) ? $dbCmdData[0]['name'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="cmdName" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/ValidationTextBox" required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{1,12}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('name') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('hostname') . '</strong></label></td>';
        $val = isset($dbCmdData[0]['idm_relay_host']) ? $dbCmdData[0]['idm_relay_host'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="cmdRelayHost" dojoType="dijit.form.ValidationTextBox" value="' . $val .  '" ';
        $response .= 'required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('hostname') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('port') . '</strong></label></td>';
        $val = isset($dbCmdData[0]['idm_relay_port']) && $dbCmdData[0]['idm_relay_port'] > 0 ? $dbCmdData[0]['idm_relay_port'] : "80";
        $response .= '<td class="table-col-input"><input type="text" name="cmdRelayPort" dojoType="dijit.form.NumberTextBox" value="' . $val .  '" ';
        $response .= 'data-dojo-props="constraints:{min:1,max:65535,places:0,pattern:\'#\'}, invalidMessage:\'' . GuiUtils::getSessionLocalizedString('invalidPortNumber') . '\'" /></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('username') . '</strong></label></td>';
        $val = isset($dbCmdData[0]['idm_relay_username']) ? $dbCmdData[0]['idm_relay_username'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="cmdRelayUser" dojoType="dijit.form.TextBox" value="' . $val .  '" /></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('password') . '</strong></label></td>';
        $val = isset($dbCmdData[0]['idm_relay_password']) ? $dbCmdData[0]['idm_relay_password'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="cmdRelayPass" dojoType="dijit.form.TextBox" value="' . $val .  '"/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('relay') . '</strong></label></td>';
        $val = isset($dbCmdData[0]['idm_relay_relay']) && $dbCmdData[0]['idm_relay_relay'] > 0 ? $dbCmdData[0]['idm_relay_relay'] : "1";
        $response .= '<td class="table-col-input"><input type="text" name="cmdRelayRelay" dojoType="dijit.form.NumberTextBox" value="' . $val .  '" ';
        $response .= 'data-dojo-props="constraints:{min:1,max:16,places:0,pattern:\'#\'}, invalidMessage:\'' . GuiUtils::getSessionLocalizedString('invalidRelayNumber') . '\'" /></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('cmdRelayType') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $cmdRelayType . '</td></tr>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('cmdInterfaceType') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $cmdGuiSelect . '</td></tr>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('cmdInterfaceColor') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $cmdColorSelect . '</td></tr>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('switchOnLabel') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $cmdOnTitle;
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('switchOffLabel') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $cmdOffTitle;

        $response .= '<tr><td class="table-col-label">&nbsp;</td>';
        $response .= '<td class="table-col-submit">';
        if($id > 0) {
            $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('duplicate');
            $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
            $response .= "callDuplicateApi('commandWrForm', 'command');";
            $response .= '</script>';
            $response .= '</button>';

            $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('delete');
            $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
            $response .= "callDeleteApi('commandWrForm', 'command');";
            $response .= '</script>';
            $response .= '</button>';
        }

        $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('save');
        $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
        $response .= '
                require(["dojo/dom-form", "dojo/query", "dojo/NodeList-manipulate",], function(domForm, query){
                    formValidateAndPut(\'commandWrForm\', \'command\', [\'cmdName\',\'cmdRelayHost\', \'cmdRelayRelay\']);
                });';
        $response .= '</script>';
        $response .= '</button></td></td>';
        $response .= '</table></form></div>';
        $dbCmdData = null;
        return $response;
    }

    public static function buildMultiSelectBox($name, $selectOptions, $defaultSel, $isDisabled=false) {
        $selectCtrlStr = '<select name="' . $name .'" style="width: 100%;" data-dojo-type="dijit/form/MultiSelect" ';
        $disabled = $isDisabled ? 'true' : 'false';
        $selectCtrlStr .= 'disabled="' . $disabled . '" multiple="true">';
        foreach($selectOptions as $row) {
            $selected = "";
            if($defaultSel != null && is_array($defaultSel)) {
                foreach($defaultSel as $defRow) {
                    if($row['id'] == $defRow['id']) {
                        $selected = ' selected="selected"';
                    }
                }
            }
            $selectCtrlStr .= '<option value="' . $row['id']  . '"' . $selected . '>' . $row['name'] . '</option>';
        }

        $selectCtrlStr .= '</select>';
        return $selectCtrlStr;
    }

    public static function doorForm($id) {
        FormsGenerator::isAuthenticated();
        $dbCmdData = null;
        if($id > 0) {
            $sql = 'select id, name, msn from doors where id=';
            $dbDoorData = DBUtils::getDbData('cfg', 'door configuration', $sql, $id);
            if(isset($dbDoorData['error'])) {
                return $dbDoorData['error'];
            }
        }

        $response = '<div id="form-div">';
        $response .= '<form id="doorsForm">';
        $response .= '<table>';
        $response .= '<input type="hidden" name="doorId" dojoType="dijit.form.TextBox" readOnly = true value="' . $id . '" />';
        $response .= '<input type="hidden" name="dupId" value="' . $id . '"/>';
        $response .= '<input type="hidden" name="dupliType" value="door"/>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('name') . '</strong></label></td>';
        $val = isset($dbDoorData[0]['name']) ? $dbDoorData[0]['name'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="doorName" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/ValidationTextBox" required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('name') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"/></td></tr>';

        $sql = "select name, username as val, 0 as isDefault from door_modules";
        $dbData = DBUtils::getDbData('sip', 'door configuration', $sql, 0, 0);
        if(empty($dbData)) {
            return '<div id="error-msg">' . GuiUtils::getSessionLocalizedString('doorModuleMustBeDefined') . '</div>';
        } else if(isset($dbData['error'])) {
            return $dbData['error'];
        }
        $doorModule = FormsGenerator::buildSelectBox('doorMsn', $dbData, isset($dbDoorData[0]['msn']) ? $dbDoorData[0]['msn'] : "-1");

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('doorModule') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $doorModule . '</td></tr>';

        $sql = "select id, name from cameras";
        $dbData = DBUtils::getDbData('cfg', 'door configuration', $sql, 0, 0);
        if(isset($dbData['error'])) {
            return $dbData['error'];
        }

        $selectedCams = null;
        if($id > 0) {
            $sql = "select cam_id as id from door_cam_link where door_id=";
            $selectedCams = DBUtils::getDbData('cfg', 'door configuration', $sql, $id, 0);
            if(isset($dbData['error'])) {
                return $dbData['error'];
            }
        }
        $doorCamsSelect = FormsGenerator::buildMultiSelectBox('doorCams', $dbData, $selectedCams);

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('doorAsocCam') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $doorCamsSelect . '</td></tr>';

        $response .= '<tr><td class="table-col-label">&nbsp;</td>';
        $response .= '<td class="table-col-submit">';
        if($id > 0) {
            $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('delete');
            $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
            $response .= "callDeleteApi('doorsForm', 'door');";
            $response .= '</script>';
            $response .= '</button>';
        }

        $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('save');
        $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
        $response .= "formValidateAndPut('doorsForm', 'door', ['doorName', 'doorMsn']);";
        $response .= '</script>';
        $response .= '</button></td></td>';

        $response .= '</table></form></div>';
        $dbDoorData = null;
        return $response;
    }

    public static function sipDefaultForm($id) {
        FormsGenerator::isAuthenticated();
        $dbSipDefData = null;
        if($id > 0) {
            $sql = 'select * from sip_defaults where id=';
            $dbSipDefData = DBUtils::getDbData('cfg', 'sip defaults configuration', $sql, $id);
            if(isset($dbSipDefData['error'])) {
                return $dbSipDefData['error'];
            }
        }

        $response = '<div id="form-div">';
        $response .= '<form id="sipDefaultForm">';
        $response .= '<table>';
        $response .= '<input type="hidden" name="sipDefId" dojoType="dijit.form.TextBox" value="' . $id . '"/>';
        $response .= '<input type="hidden" name="dupId" value="' . $id . '"/>';
        $response .= '<input type="hidden" name="dupliType" value="sipDefault"/>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('name') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['name']) ? $dbSipDefData[0]['name'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefName" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/ValidationTextBox" required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('name') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('serverUrl') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['SIPServerURL']) ? $dbSipDefData[0]['SIPServerURL'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefSIPServerURL" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/ValidationTextBox" required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('serverUrl') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"/></td></tr>';

        $siedleChecked = "";
        $idmChecked = "";
        $idorChecked = " checked ";
        if(isset($dbSipDefData[0]['SIPDoorSystemType'])) {
          if($dbSipDefData[0]['SIPDoorSystemType'] == 'iDM' || $dbSipDefData[0]['SIPDoorSystemType'] == '0') {
            $siedleChecked = "";
            $idmChecked = " checked ";
            $idorChecked = "";
          } else if($dbSipDefData[0]['SIPDoorSystemType'] == 'Siedle' || $dbSipDefData[0]['SIPDoorSystemType'] == '1') {
            $siedleChecked = " checked ";
            $idmChecked = "";
            $idorChecked = "";
          }
        }

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('doorSystemType') . '</strong></label></td>';
        $response .= '<td class="table-col-input">';
        $response .= '<input type="radio" data-dojo-type="dijit/form/RadioButton" name="sipDefSIPDoorSystemType"' . $idorChecked . 'value="iDor" onchange="onChangeDoorType(this)"/> <label>iDor</label>';
        $response .= '<input type="radio" data-dojo-type="dijit/form/RadioButton" name="sipDefSIPDoorSystemType"' . $siedleChecked . 'value="Siedle" onchange="onChangeDoorType(this)"/> <label>Siedle</label>';
        $response .= '<input type="radio" data-dojo-type="dijit/form/RadioButton"' . $idmChecked . 'name="sipDefSIPDoorSystemType" value="iDM" onchange="onChangeDoorType(this)"/> <label>IPVC</label></td></tr>';

        $checked = "";
        $disableDpendentCtrl = ' disabled="true" ';
        if(isset($dbSipDefData[0]['SIPAllowMakeCall']) && $dbSipDefData[0]['SIPAllowMakeCall'] != '0') {
            $checked = "checked ";
            $disableDpendentCtrl = '';
        }

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('conciergeCall') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input dojoType="dijit/form/CheckBox" value="1" ' . $checked . 'name="sipDefSIPAllowMakeCall" onChange="onChangeConciergeCall"/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('ConciergeMsn') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['MainDoorMSN']) ? $dbSipDefData[0]['MainDoorMSN'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefMainDoorMSN" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/ValidationTextBox" required:"true" ' . $disableDpendentCtrl;
        $response .= 'data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('ConciergeMsn') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('conciergeButtonName') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['CallButtonName']) ? $dbSipDefData[0]['CallButtonName'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefCallButtonName" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/ValidationTextBox" required:"true" ' . $disableDpendentCtrl;
        $response .= 'data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('conciergeButtonName') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"/></td></tr>';

        $checked = "";
        if(isset($dbSipDefData[0]['SIPNotificationBasedSystem']) && $dbSipDefData[0]['SIPNotificationBasedSystem'] != '0') {
            $checked = "checked ";
        }
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('pushNotification') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input dojoType="dijit/form/CheckBox" value="1" ' . $checked . 'name="sipDefSIPNotificationBasedSystem" /></td></tr>';

        $response .= '</table><div data-dojo-type="dijit/TitlePane" data-dojo-props="title: \'' . GuiUtils::getSessionLocalizedString('advancedSettings') . '\', open:false">';
        $response .= '<table>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('serverPort') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['SIPServerPort']) ? $dbSipDefData[0]['SIPServerPort'] : "5060";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefSIPServerPort" required:"true" value="' . $val .  '" ';
        $response .= 'dojoType="dijit.form.NumberTextBox" data-dojo-props="constraints:{min:1,max:65535,places:0,pattern:\'#\'}, invalidMessage:\'' . GuiUtils::getSessionLocalizedString('invalidValue') . '\'"';
        $response .= ' disabled=false /></td></tr>';

        $checked = "";
        if(isset($dbSipDefData[0]['SIPUseOnlyUdp']) && $dbSipDefData[0]['SIPUseOnlyUdp'] != '0') {
            $checked = "checked ";
        }
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('udpModeOnly') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input dojoType="dijit/form/CheckBox" value="1" ' . $checked . 'name="sipDefSIPUseOnlyUdp" /></td></tr>';


        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('openDoorDtmf') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['OpenDoorDTMF']) ? $dbSipDefData[0]['OpenDoorDTMF'] : "#";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefOpenDoorDTMF" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/TextBox" /></td></tr>';


        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('answerDoorDtmf') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['AnswerDoorDTMF']) ? $dbSipDefData[0]['AnswerDoorDTMF'] : "1";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefAnswerDoorDTMF" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/TextBox" /></td></tr>';


        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('hangupDtmf') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['HangUpDTMF']) ? $dbSipDefData[0]['HangUpDTMF'] : "1";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefHangUpDTMF" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/TextBox" /></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('dtmfDelay') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['DelayDTMF']) ? $dbSipDefData[0]['DelayDTMF'] : "5";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefDelayDTMF" value="' . $val .  '" ';
        $response .= 'dojoType="dijit.form.NumberTextBox" data-dojo-props="constraints:{min:0,max:1000,places:0,pattern:\'#\'}, invalidMessage:\'' . GuiUtils::getSessionLocalizedString('invalidValue') . '\'"';
        $response .= ' disabled=false /></td></tr>';

        $checked = "";
        $disableDpendentCtrl = ' disabled="true" ';
        if(isset($dbSipDefData[0]['InbandDTMF']) && $dbSipDefData[0]['InbandDTMF'] != '0') {
            $checked = "checked ";
            $disableDpendentCtrl = '';
        }
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('inbandDtmf') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input dojoType="dijit/form/CheckBox" value="1" ' . $checked . 'name="sipDefInbandDTMF" onChange="onChangeInbandDTMF"/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('clockRate') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['InbandDTMFClockRate']) ? $dbSipDefData[0]['InbandDTMFClockRate'] : "8000";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefInbandDTMFClockRate" required:"true" value="' . $val .  '" ';
        $response .= 'dojoType="dijit.form.NumberTextBox" ' . $disableDpendentCtrl;
        $response .= ' data-dojo-props="constraints:{min:1,max:100000,places:0,pattern:\'#\'}, invalidMessage:\'' . GuiUtils::getSessionLocalizedString('invalidValue') . '\'" /></td></tr>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('channels') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['InbandDTMFChannels']) ? $dbSipDefData[0]['InbandDTMFChannels'] : "1";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefInbandDTMFChannels" required:"true" value="' . $val .  '" ';
        $response .= 'dojoType="dijit.form.NumberTextBox" ' . $disableDpendentCtrl;
        $response .= ' data-dojo-props="constraints:{min:1,max:2,places:0,pattern:\'#\'}, invalidMessage:\'' . GuiUtils::getSessionLocalizedString('invalidValue') . '\'" /></td></tr>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('sampleFrame') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['InbandDTMFSamplesPerFrame']) ? $dbSipDefData[0]['InbandDTMFSamplesPerFrame'] : "160";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefInbandDTMFSamplesPerFrame" required:"true" value="' . $val .  '" ';
        $response .= 'dojoType="dijit.form.NumberTextBox" ' . $disableDpendentCtrl;
        $response .= ' data-dojo-props="constraints:{min:1,max:8000,places:0,pattern:\'#\'}, invalidMessage:\'' . GuiUtils::getSessionLocalizedString('invalidValue') . '\'" /></td></tr>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('bitsSample') . '</strong></label></td>';
        $val = isset($dbSipDefData[0]['InbandDTMFBitsPerSample']) ? $dbSipDefData[0]['InbandDTMFBitsPerSample'] : "16";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefInbandDTMFBitsPerSample" required:"true" value="' . $val .  '" ';
        $response .= 'dojoType="dijit.form.NumberTextBox" ' . $disableDpendentCtrl;
        $response .= ' data-dojo-props="constraints:{min:1,max:128,places:0,pattern:\'#\'}, invalidMessage:\'' . GuiUtils::getSessionLocalizedString('invalidValue') . '\'"/></td></tr>';

/*
        $checked = "";
        $disableDpendentCtrl = ' disabled="true" ';
        if(isset($dbSipDefData[0]['SIPUseStunServers']) && $dbSipDefData[0]['SIPUseStunServers'] != '0') {
            $checked = "checked ";
            $disableDpendentCtrl = '';
        }
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('useStunServers') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input dojoType="dijit/form/CheckBox" value="1" ' . $checked . 'name="sipDefSIPUseStunServers" onChange="onChangeSIPUseStunServers"/></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('stunServer') . ' 1</strong></label></td>';
        $val = isset($dbSipDefData[0]['STUNServer1']) ? $dbSipDefData[0]['STUNServer1'] : "stun.phonepower.com";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefSTUNServer1" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/TextBox"' . $disableDpendentCtrl . ' /></td></tr>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('stunServer') . ' 2</strong></label></td>';
        $val = isset($dbSipDefData[0]['STUNServer2']) ? $dbSipDefData[0]['STUNServer2'] : "stun.callwithus.com";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefSTUNServer2" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/TextBox"' . $disableDpendentCtrl . ' /></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('stunServer') . ' 3</strong></label></td>';
        $val = isset($dbSipDefData[0]['STUNServer3']) ? $dbSipDefData[0]['STUNServer3'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefSTUNServer3" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/TextBox"' . $disableDpendentCtrl . ' /></td></tr>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('stunServer') . ' 4</strong></label></td>';
        $val = isset($dbSipDefData[0]['STUNServer4']) ? $dbSipDefData[0]['STUNServer4'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="sipDefSTUNServer4" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/TextBox"' . $disableDpendentCtrl . ' /></td></tr>';
        */
        $checked = "";
        if(isset($dbSipDefData[0]['SIPDebugMode']) && $dbSipDefData[0]['SIPDebugMode'] != '0') {
            $checked = "checked ";
        }
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('enableDebug') . '</strong></label></td>';
        $response .= '<td class="table-col-input"><input dojoType="dijit/form/CheckBox" value="1" ' . $checked . 'name="sipDefSIPDebugMode" /></td></tr>';

        $response .= '</table></div><table>';
        $response .= '<tr><td class="table-col-label">&nbsp;</td>';
        $response .= '<td class="table-col-submit">';
        if($id > 0) {
            $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('duplicate');
            $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
            $response .= "callDuplicateApi('sipDefaultForm', 'sipDefault');";
            $response .= '</script>';
            $response .= '</button>';

            $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('delete');
            $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
            $response .= "callDeleteApi('sipDefaultForm', 'sipDefault');";
            $response .= '</script>';
            $response .= '</button>';
        }

        $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('save');
        $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
        $response .= '
                require(["dojo/dom-form", "dojo/query", "dojo/NodeList-manipulate",], function(domForm, query){
                    var valCtrl = [\'sipDefName\', \'sipDefSIPServerURL\', \'sipDefSIPServerPort\'];
                    dojo.forEach(dojo.query("[name^=\'sipDefSIPAllowMakeCall\']"), function(domnode) {
                        if(dijit.getEnclosingWidget(domnode).get(\'value\') == true) {
                            valCtrl.push(\'sipDefMainDoorMSN\');
                            valCtrl.push(\'sipDefCallButtonName\');
                        }
                    });
                    dojo.forEach(dojo.query("[name^=\'sipDefInbandDTMF\']"), function(domnode) {
                        if(dijit.getEnclosingWidget(domnode).get(\'value\') == true) {
                            valCtrl.push(\'InbandDTMFClockRate\');
                            valCtrl.push(\'InbandDTMFChannels\');
                            valCtrl.push(\'InbandDTMFSamplesPerFrame\');
                            valCtrl.push(\'InbandDTMFBitsPerSample\');
                        }
                    });

                    formValidateAndPut(\'sipDefaultForm\', \'sipDefault\', valCtrl);
                });';
        $response .= '</script>';
        $response .= '</button></td></td>';

        $response .= '</table></form></div>';
        $dbSipDefData = null;
        return $response;
    }

    public static function cfgBundleForm($id) {
        FormsGenerator::isAuthenticated();
        $dbCfgData = null;
        if($id > 0) {
            $sql = 'select id, name, level, sip_defaults_id from config_bundles where id=';
            $dbCfgData = DBUtils::getDbData('cfg', 'bundle configuration error', $sql, $id);
            if(isset($dbCfgData['error'])) {
                return $dbCfgData['error'];
            }
        }

        $response = '<div id="form-div">';
        $response .= '<form id="cfgBundleForm">';
        $response .= '<table>';
        $response .= '<input type="hidden" name="cfgBundleId" dojoType="dijit.form.TextBox" value="' . $id . '"/>';
        $response .= '<input type="hidden" name="dupId" value="' . $id . '"/>';
        $response .= '<input type="hidden" name="dupliType" value="cfgBundle"/>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('name') . '</strong></label></td>';
        $val = isset($dbCfgData[0]['name']) ? $dbCfgData[0]['name'] : "";
        $response .= '<td class="table-col-input"><input type="text" name="cfgBundleName" value="' . $val .  '" ';
        $response .= 'dojoType="dijit/form/ValidationTextBox" required:"true" data-dojo-props="regExp:\'[\\\\w\\\\s]{3,128}\', ';
        $response .= 'invalidMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\', promptMessage:\'';
        $response .=  GuiUtils::getSessionLocalizedString('name') . '\', missingMessage:\'' . GuiUtils::getSessionLocalizedString('fieldRequired') . '\'"/></td></tr>';

        $cfgBundleGlobalLevel = " checked:true, ";
        $cfgBundleAppartmentLevel = " checked:false, ";
        $cfgBundleUserLevel = " checked:false, ";
        $apartmentSelectIsDisabled = true;
        $userSelectIsDisabled = true;
        if(isset($dbCfgData[0]['level'])) {
            if($dbCfgData[0]['level'] == 'Apartment') {
                $cfgBundleGlobalLevel = " checked:false,";
                $cfgBundleAppartmentLevel = " checked:true, ";
                $apartmentSelectIsDisabled = false;
            } else if($dbCfgData[0]['level'] == 'SipAccount') {
                $cfgBundleGlobalLevel = " checked:false, ";
                $cfgBundleUserLevel = " checked:true, ";
                $userSelectIsDisabled = false;
            }
        }

        $sql = "select id, name, 0 as isDefault from apartments";
        $dbData = DBUtils::getDbData('sip', 'config bundle configuration', $sql, 0, 0);
        $cfgBundleLevelApartmentDisabled = '';
        if(empty($dbData) || isset($dbData['error'])) {
            $cfgBundleLevelApartmentDisabled = ' disabled="true" ';
            $apartmentSelectIsDisabled = true;
            $dbData = array();
        }

        $selectedApartments = null;
        if($id > 0) {
            $sql = "select assoc_id as id from config_bundles_links where type='Apartment' and cfg_bundle_id=";
            $selectedApartments = DBUtils::getDbData('cfg', 'config bundle configuration', $sql, $id, 0);
            if(isset($dbData['error'])) {
              return $dbData['error'];
            }
        }

        $apartmentSelect = FormsGenerator::buildMultiSelectBox('cfgBundleApartmentId', $dbData, $selectedApartments, $apartmentSelectIsDisabled);

        $sql = "select id, concat(name, '-', username) as name, 0 as isDefault from sip_accounts";
        $dbData = DBUtils::getDbData('sip', 'config bundle configuration', $sql, 0, 0);
        $cfgBundleLevelUserDisabled = '';
        if(empty($dbData) || isset($dbData['error'])) {
            $cfgBundleLevelUserDisabled = ' disabled="true" ';
            $userSelectIsDisabled = true;
            $dbData = array();
        }
        $selectedUsers = null;
        if($id > 0) {
            $sql = "select assoc_id as id from config_bundles_links where type='SipAccount' and cfg_bundle_id=";
            $selectedUsers = DBUtils::getDbData('cfg', 'config bundle configuration', $sql, $id, 0);
            if(isset($dbData['error'])) {
              return $dbData['error'];
            }
        }

        $userSelect = FormsGenerator::buildMultiSelectBox('cfgBundleUserId', $dbData, $selectedUsers, $userSelectIsDisabled);

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('cfgBundleLevel') . '</strong></label></td>';
        $response .= '<td class="table-col-input">';
        $response .= '<input type="radio" data-dojo-type="dijit/form/RadioButton" name="cfgBundleLevel" data-dojo-props=\'value:"Global", ' . $cfgBundleGlobalLevel . 'onChange:function(checked){onCfgBundleGlobal(checked);}\'/> <label>Global</label>';
        $response .= '<input type="radio" data-dojo-type="dijit/form/RadioButton"' . $cfgBundleLevelApartmentDisabled . 'name="cfgBundleLevel" data-dojo-props=\'value:"Apartment", ' . $cfgBundleAppartmentLevel . 'onChange:function(checked){onCfgBundleApartment(checked);}\'/> <label>Apartment</label>';
        $response .= '<input type="radio" data-dojo-type="dijit/form/RadioButton"' . $cfgBundleLevelUserDisabled . 'name="cfgBundleLevel" data-dojo-props=\'value:"SipAccount", ' . $cfgBundleUserLevel . 'onChange:function(checked){onCfgBundleUser(checked);}\'/> <label>User</label></td></tr>';

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('apartment') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $apartmentSelect . '</td></tr>';
        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('cfgSipUser') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $userSelect . '</td></tr>';

        $sql = "select id as val, name, 0 as isDefault from sip_defaults";
        $dbData = DBUtils::getDbData('cfg', 'config bundle configuration', $sql, 0);
        if(empty($dbData) || isset($dbData['error'])) {
            return '<div id="error-msg">' . GuiUtils::getSessionLocalizedString('sipDefNotDefinedError') . '</div>';
        }
        $sipDefSelect = FormsGenerator::buildSelectBox('cfgBundleSipDefId', $dbData, isset($dbCfgData[0]['sip_defaults_id']) ? $dbCfgData[0]['sip_defaults_id'] : "-1");


        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('cfgSipDefSettings') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $sipDefSelect . '</td></tr>';


        $sql = "select id, name from doors";
        $dbData = DBUtils::getDbData('cfg', 'config bundle configuration', $sql, 0, 0);
        if(isset($dbData['error'])) {
            $dbData = array();
        }

        $selectedDoors = null;
        if($id > 0) {
            $sql = "select assoc_id as id from config_bundles_links where type='Door' and cfg_bundle_id=";
            $selectedDoors = DBUtils::getDbData('cfg', 'config bundle configuration', $sql, $id, 0);
            if(isset($dbData['error'])) {
                return $dbData['error'];
            }
        }
        $cfgBundleDoorsSelect = FormsGenerator::buildMultiSelectBox('cfgBundleDoors', $dbData, $selectedDoors);

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('door') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $cfgBundleDoorsSelect . '</td></tr>';

        $sql = "select id, name from cameras";
        $dbData = DBUtils::getDbData('cfg', 'config bundle configuration', $sql, 0);
        if(isset($dbData['error'])) {
            $dbData = array();
        }

        $selectedCameras = null;
        if($id > 0) {
            $sql = "select assoc_id as id from config_bundles_links where type='Camera' and cfg_bundle_id=";
            $selectedCameras = DBUtils::getDbData('cfg', 'config bundle configuration', $sql, $id, 0);
            if(isset($dbData['error'])) {
                return $dbData['error'];
            }
        }
        $cfgBundleCamsSelect = FormsGenerator::buildMultiSelectBox('cfgBundleCams', $dbData, $selectedCameras);

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('camera') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $cfgBundleCamsSelect . '</td></tr>';

        $sql = "select id, name from commands";
        $dbData = DBUtils::getDbData('cfg', 'config bundle configuration', $sql, 0);
        if(isset($dbData['error'])) {
            $dbData = array();
        }

        $selectedCommands = null;
        if($id > 0) {
            $sql = "select assoc_id as id from config_bundles_links where type='Command' and cfg_bundle_id=";
            $selectedCommands = DBUtils::getDbData('cfg', 'config bundle configuration', $sql, $id, 0);
            if(isset($dbData['error'])) {
                return $dbData['error'];
            }
        }
        $cfgBundleCmdsSelect = FormsGenerator::buildMultiSelectBox('cfgBundleCmds', $dbData, $selectedCommands);

        $response .= '<tr><td class="table-col-label"><strong>' . GuiUtils::getSessionLocalizedString('controls') . '</strong></label></td>';
        $response .= '<td class="table-col-input">' . $cfgBundleCmdsSelect . '</td></tr>';

        $response .= '<tr><td class="table-col-label">&nbsp;</td>';
        $response .= '<td class="table-col-submit">';
        if($id > 0) {
            $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('delete');
            $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
            $response .= "callDeleteApi('cfgBundleForm', 'cfgBundle');";
            $response .= '</script>';
            $response .= '</button>';
        }

        $response .= '<button data-dojo-type="dijit.form.Button" name="submitButton" value="Submit">' . GuiUtils::getSessionLocalizedString('save');
        $response .= '<script type="dojo/on" data-dojo-event="click" data-dojo-args="evt">';
        $response .= "formValidateAndPut('cfgBundleForm', 'cfgBundle', ['cfgBundleName']);";
        $response .= '</script>';
        $response .= '</button></td></td>';

        $response .= '</table></form></div>';
        $dbCfgData = null;
        return $response;
    }
}
